#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated. 
import string
try:
   import MySQLdb
except:
   pass # wenn es bei Windows noch nicht installiert ist.
import urllib
import sys
import re
import types
import time
import os
import glob
import zipfile
import shutil
import cPickle
import threading
import md5
import urlparse

meldung = "Anfangsmeldung"
GUI = 1
DATENBANK_USER = "einzelplatz"
# so heit der mysql-User - immer, auch in der Internet-Version.
# Der Name hat traditionelle Grnde. Durch die Benutzung nur eines
# Users kann ich eine Datenbank benutzen, bei der ich - z.B. bei einem
# Provider - nur einen einzigen Benutzernamen und ein einziges Passwort habe.
# Beachte die notwendigen nderungen der Datei passwort.py und im Konfigurationsteil
# von verwaltungMainServer.py.

try:
   from Tkinter import *
except:
   GUI = 0
   sys.exit("Zur Installation und zum Betrieb des Bezirksreiters \nmuessen Sie Python mit Tkinter-Untersttzung installiert haben. \nBitte konsultieren Sie das \nHandbuch ihres Betriebssystems oder schicken Sie \neine E-Mail an me.simon@t-online.de!")
DEBUG = 1

class ScrolledText(Frame):    
    def __init__(self,parent=None, text="", file=None, height=10):
        Frame.__init__(self, parent)
        self.height=height
        self.pack(expand=YES, fill=BOTH)
        self.makeWidgets()
        self.settext(text, file)

    def makeWidgets(self):
        sbar = Scrollbar(self)
        text = Text(self, relief=SUNKEN, bg="white",height=self.height)
        sbar.config(command=text.yview)
        text.config(yscrollcommand=sbar.set)
        sbar.pack(side=RIGHT, fill=Y)
        text.pack(side=LEFT, expand=YES, fill=BOTH)
        self.text = text

    def settext(self, text="", file=None):
        if file:
            text = open(file,"r").read()
        self.text.delete("1.0", END)
        self.text.insert("1.0", text)
        #self.text.mark_set(INSERT, "1.0")
        #self.text.focus()

    def gettext(self):
        return self.text.get("1.0", END+"-1c")

    def write(self,text=""):
        # damit kann man stdout umlenken
        self.text.insert(END,text)
        self.text.see(END)
        self.text.update()

class ScrolledList(Frame):    
    def __init__(self, options, parent=None):        
        Frame.__init__(self, parent)
        self.pack(expand=YES, fill=BOTH)
        self.makeWidgets(options)
        self.label = ""
        self.index = 0
        self.parent = parent
        
    def handleList(self, event):
        self.index = self.listbox.curselection()
        self.label = self.listbox.get(self.index)
        self.listbox.get(self.index)
        self.runCommand()

    def makeWidgets(self, options):
        sbar = Scrollbar(self)
        list = Listbox(self, relief=SUNKEN)
        sbar.config(command=list.yview)
        list.config(yscrollcommand=sbar.set)
        sbar.pack(side=RIGHT,fill=Y)
        list.pack(side=LEFT, expand=YES, fill=X)
        pos = 0
        for label in options:
            list.insert(pos, label)
            pos += 1
            #list.config(selectmode=SINGLE, setgrid=1)
            list.bind("<Double-1>", self.handleList)
            self.listbox = list

    def runCommand(self):
        print "Sie haben gewaehlt: ", self.label

class functionalScrolledList(ScrolledList):
    # Ruft bei Doppelklick eine bergebene Funktion auf.
    # bergibt den aktuell gewhlten Index der Liste.
    # Lscht dann automatisch die Liste vom Bildschirm.
    def __init__(self,options,function,parent=None):
        self.function = function
        ScrolledList.__init__(self,options,parent)

    def runCommand(self):
        self.function(int(self.index[0]))
        # der Listenindex enthlt ein einelementiges
        # String-Tupel: Umwandlung in Integer
        self.parent.destroy()

class entryField(Frame):
    def __init__(self,feldnamen,parent=None,labellaenge=20):
        Frame.__init__(self,parent)
        #self.pack(side=LEFT,expand=YES,fill=X)
        self.felder_dict = self.felderErzeugen(feldnamen,labellaenge=labellaenge)

    def felderErzeugen(self,feldnamen,labellaenge=20):
        tempdict = {}
        for feld in feldnamen:
            Label(self,width=labellaenge,text=feld).pack(side=LEFT)
            tempentry = Entry(self)
            tempentry.pack(side=RIGHT,expand=YES,fill=X)
            var = StringVar()
            tempentry.config(textvariable=var)
            tempdict[feld] = var
        return tempdict

    def feldHolen(self,feld):
        try:
            return self.felder_dict[feld].get()
        except:
            return ""

    def feldSetzen(self,feld,wert):
        try:
            self.felder_dict[feld].set(wert)
            return 1
        except:
            return 0



class Install:
   """Das Interface fr alle Install-Klassen. Die Instanzen selbst werden von
   einer globalen Factory-Funktion UniversalInstall systemabhngig aus den Unterklasssen erzeugt.
   Die Klasse Install kann nicht fr sich Instanzen bilden, nur die Unterklassen!"""
   def __init__(self, systemmeldung):
      """Diese Funktion setzt voraus, da im Konstruktor der Subklasse bereits
      einige Variablen (systemspezifisch) initialisiert wurden."""
      self.systemmeldung = systemmeldung
      self.browser = {}
      self.lieblingsbrowser = ""
      self.spacetest = re.compile(r"\\(\w*\s\w*)")
      self.musterkartei = ("musterkartei","musterevang","musteremkadressen")
      self.installProtokoll = os.path.normpath(os.path.join(self.tempinstall,"install_protokoll"))
      self.mysql_root_passwort = "" # wird spter abgefragt
      self.mysql_root_verbindung = "" # wird spter erzeugt
      self.mysql_root_cursor = "" # wird spter erzeugt
      self.admin_name = "" # wird spter abgefragt
      self.admin_passwort = "" # wird spter abgefragt
      self.master_passwort = "12345" # wird spter abgefragt
      self.admin_email = "" # wird spter abgefragt
      self.server_cgi = """./""" # wird spter abgefragt      
      self.standard_url = """http://localhost:8000"""
      self.url = self.standard_url # wird spter abgefragt
      self.vereinfachteInstallation = "ja" # wird spter abgefragt
      self.cgi_datei = """/cgi-bin/verwaltungMainServer.py"""
      self.frame_datei = """/verwaltungMain.htm"""
      self.mysql_neue_datenbanken = ["musterkartei","musterevang","musteremkadressen"] # zustzliche werden spter erzeugt
      if GUI:
         self.hauptfensterErzeugen()

   def hauptfensterErzeugen(self):
      self.hauptfenster = Tk()
      self.hauptfenster.title("Bezirksreiter - Das Installationsprogramm")
      self.savestream = sys.stdout
      self.tempspeicher = None
      self.obenframe = Frame(self.hauptfenster,bg="#fbffa9")
      self.obenframe.pack(side=TOP, expand=YES, fill=BOTH)
      #self.bild = PhotoImage(file="Circut5.gif")
      #Label(self.hauptfenster,text="Bild",image=self.bild).pack(side=TOP, expand=YES, fill=BOTH)
      #self.can = Canvas(self.hauptfenster)
      #self.can.create_image(2, 2, image=self.bild, anchor=NW)
      #self.can.pack(side=TOP, expand=YES, fill=BOTH)
      #Label(self.obenframe, image=self.bild).pack(side=LEFT, expand=YES, fill=X)
      Label(self.obenframe, text="""Technische Meldungen des Installationsprogramms \nim weien Feld:\n(Fr Interessierte, zur Fehlersuche usw.)""",bg="#fbffa9").pack(side=RIGHT, expand=YES, fill=X)
      self.textfeld = ScrolledText(self.hauptfenster)
      self.fastuntenframe = Frame(self.hauptfenster)
      self.fastuntenframe.pack(side=TOP, expand=YES,fill=BOTH)
      self.untenframe = Frame(self.hauptfenster)
      self.untenframe.pack(side=TOP, expand=YES, fill=BOTH)
      self.hauptlabel = Label(self.fastuntenframe, text="",width=60,height=9,bg="#dcffcc")
      self.hauptlabel.pack(side=BOTTOM, expand=YES, fill=BOTH)
      self.eingabe = entryField(["Eingabefeld"],self.untenframe,labellaenge=20)
      self.eingabe.pack(side=LEFT, expand=YES, fill=X)
##      self.abstandlabel = Label(self.hauptfenster, text="")
##      self.abstandlabel.pack()
      self.ok_button = Button(self.untenframe, text="Weiter")
      self.ok_button.pack(side=LEFT, expand=YES, fill=X)
      self.no_button = Button(self.untenframe, command=self.hauptfenster.destroy,text="Abbruch")
      self.no_button.pack(side=LEFT, expand=YES, fill=X)
##      self.faxButton.pack(side=LEFT)
##      self.faxButton.bind("<Enter>", self.buttonFaerben)
##      self.faxButton.bind("<Leave>", self.buttonEntfaerben)
##      Button(self.hauptfenster, text="Vorschau", command=self.vorschau).pack(side=LEFT)
##      Button(self.hauptfenster, text="Lschen", command=self.faxnummerLoeschen).pack(side=LEFT)
##      Button(self.hauptfenster, text="Telefonbuch", command=self.telefonbuch_anzeigen).pack(side=LEFT)
##      self.modemButton = Button(self.hauptfenster, text="Modem %s" % self.modem, command=self.modemWechseln)
##      self.modemButton.pack(side=LEFT)
##      Button(self.hauptfenster, text="Beenden", command=self.beenden).pack(side=RIGHT)
##      self.entry.feldSetzen("Faxnummer","Statt diesem Text Faxnummer eingeben oder Telefonbuch aufrufen")
      sys.stdout = self.textfeld
      self.installGui()
      self.hauptfenster.mainloop()

   def popupFehler(self,meldung="Bei der Installation des Bezirksreiters ist ein Fehler aufgetreten: \nBitte lesen Sie die Ausgabe im weien Fenster \nund beenden Sie dann das Programm!"):
      root = Toplevel(self.hauptfenster,bg="red")
      Label(root,text=meldung,bg="red").pack()
      Button(root,text="Beenden",command=self.hauptfenster.destroy,bg="green").pack()      
      root.focus_set()
      root.grab_set()
      root.mainloop()

   def mxDateTimePruefen(self):
      test = 0
      try:
         import mx.DateTime
         test = 1
      except:
         try:
            import DateTime # Bezeichnung bei alten Installationen
            test = 1
         except:
            try:
               import datetime # bei ganz neuen Installationen
               test = 1
            except:
               pass
      ##if test:
##         self.popupWarnung("Achtung, Sie haben das Python-mx.DateTime-Modul installiert. \nDies kann beim Bezirksreiter zur Verlangsamung des Programms fhren,\n verursacht aber sehr wahrscheinlich keine Fehlfunktionen. \nWenn Sie das Modul nicht fr andere Programme brauchen, \n deinstallieren Sie es bitte!") # abgeschaltet - zu unzuverlssig
    

   def popupWarnung(self,meldung):
      root = Toplevel(self.hauptfenster,bg="red")
      Label(root,text=meldung,bg="red").pack()
      Button(root,text="Weiter",bg="green",command=root.destroy).pack()      
      root.focus_set()
      root.grab_set()
      root.mainloop()

   def adminCheckinErzeugen(self):
      print "hier adminCheckinErzeugen"
      add = "4g5t" # Achtung, eine hartcodierte Konstante, vgl. verwaltungMainServer!
      gesamt = {}
      for d in self.mysql_neue_datenbanken:
         checkin = md5.new(self.admin_name+self.admin_passwort+add+d).hexdigest()
         temp = (checkin,self.admin_email,"a","mail")
         # die Kennzeichnung "a" erhlt nur der Administrator.
         gesamt[d] = {self.admin_name: temp}
      pfad = os.path.normpath(os.path.join(self.bezirksreiter,"checkin")) 
      file = open(pfad,"wb")
      cPickle.dump(gesamt,file)
      file.close()

   def adminConfigErzeugen(self):
      # ergnzt die config.py um einige Grunddaten
      print "hier adminConfigErzeugen"
      pfad = os.path.normpath(os.path.join(self.bezirksreiter,"admin_config.py"))
      file = open(pfad,"wb")
      temp = """# Diese Datei wurde bei der Installation erzeugt\n# und bleibt bei Updates erhalten.\nNAME_ADMIN = '%s'\nEMAIL_ADMIN = '%s'\nCGI = '%s'\nschaltzentrale = '%s'\n""" % (self.admin_name,self.admin_email,self.server_cgi,urlparse.urljoin(self.url,self.cgi_datei))
      file.write(temp)
      file.close()

   def linksUmwandeln(self):
      # darf erst nach der Installation der Dateien aufgerufen werden!
      if self.standard_url == self.url:
         return 1
      liste = os.listdir(self.bezirksreiter)
      for datei in liste:
         if datei[-3:] == "htm":
            print datei
            stringalt = urlparse.urljoin(self.standard_url,self.cgi_datei)
            stringneu = urlparse.urljoin(self.url,self.cgi_datei)
            self.stringErsetzenDatei(os.path.normpath(os.path.join(self.bezirksreiter,datei)),stringalt,stringneu)
      return 1
            

   def passwortDateiErzeugen(self):
      string = """
datenbank_passwort = "%s"
datenbank_user = "einzelplatz"
""" % self.master_passwort
      pfad = os.path.normpath(os.path.join(self.bezirksreiter,"passwort.py")) 
      file = open(pfad,"wb")
      file.write(string)
      file.close()      

   def emailEingabeGui(self):
      print "hier emailEingabeGui"
      self.hauptlabelAusgabe("""Bitte geben Sie im Eingabefeld \nihre E-Mail-Adresse an\n(fr die E-Mail-Funktion).\nDiese Adresse wird dann als Administrator-Adresse verwendet:""")
      self.untenframeWarten(self.ok_button)
      self.admin_email = self.eingabe.feldHolen("Eingabefeld")
      self.eingabe.feldSetzen("Eingabefeld","")

   def adminNameGui(self):
      print "hier adminNameGui"
      self.hauptlabelAusgabe("""Bitte geben Sie im Eingabefeld \nden Benutzernamen fr den Hauptbenutzer\n("Administrator") an.\nVerwenden Sie nur Buchstaben (keine Umlaute)\n und Unterstriche, z.B. "Karl_Mueller":""")
      self.untenframeWarten(self.ok_button)
      self.admin_name = self.eingabe.feldHolen("Eingabefeld")
      self.eingabe.feldSetzen("Eingabefeld","")

   def adminPasswortGui(self):
      print "hier adminPasswortGui"
      self.hauptlabelAusgabe("""Bitte geben Sie im Eingabefeld \ndas Passwort fr den Hauptbenutzer\n("Administrator") an.\nVerwenden Sie kleine und groe Buchstaben und Zahlen\nz.B. "59atH7".""")
      self.untenframeWarten(self.ok_button)
      self.admin_passwort = self.eingabe.feldHolen("Eingabefeld")
      self.eingabe.feldSetzen("Eingabefeld","")
      self.passwortDateiErzeugen() # Hier, weil sie unten gebraucht wird zur Datenbank-Erzeugung   

   def installModusGui(self):
      print "hier installModusGui"
      self.hauptlabelAusgabe("""Vereinfachte Installation fr Benutzung\n auf einzelnem PC (empfohlen)? \n\nAnsonsten (fr Netzwerk etc.): \nndern Sie die Vorgabe auf "nein".""")
      self.eingabe.feldSetzen("Eingabefeld",self.vereinfachteInstallation)
      self.untenframeWarten(self.ok_button)
      self.vereinfachteInstallation = self.eingabe.feldHolen("Eingabefeld")
      self.eingabe.feldSetzen("Eingabefeld","")

   def masterPasswortGui(self):
      print "hier masterPasswortGui"
      print "masterpasswort: %s" % self.master_passwort
      self.hauptlabelAusgabe("""Bitte geben Sie im Eingabefeld \ndas Masterpasswort fr alle Datenbanken an.\nVerwenden Sie kleine und groe Buchstaben und Zahlen\nz.B. "59atH7".\nAchtung: dieses Passwort kann nur \ndurch Neuinstallationgendert werden!""")
      self.eingabe.feldSetzen("Eingabefeld","")
      self.untenframeWarten(self.ok_button)
      self.master_passwort = self.eingabe.feldHolen("Eingabefeld")
      self.passwortDateiErzeugen() # Hier, weil sie unten gebraucht wird zur Datenbank-Erzeugung 
      self.eingabe.feldSetzen("Eingabefeld","")  

   def schaltzentraleGui(self):
      print "hier schaltzentraleGui"
      self.hauptlabelAusgabe("""Geben Sie hier ein, wie die URL ihres Servers lautet. \n\nFr die Einzelplatz-Installation:\nVorgabe belassen.""")
      self.eingabe.feldSetzen("Eingabefeld",self.standard_url)
      self.untenframeWarten(self.ok_button)
      self.url = self.eingabe.feldHolen("Eingabefeld")
      self.eingabe.feldSetzen("Eingabefeld","")

   def serverCgiGui(self):
      print "hier serverCgiGui"
      self.hauptlabelAusgabe("""Geben Sie hier ein, wo sich ihre cgi-bin\naus der Sicht ihres Internet-Servers(!) befindet.\nz.B.: /home/www/karl/mueller.de/cgi-bin/\n\nFr die Einzelplatz-Installation und die Intranet-Installation\n(mit cgiserver_verwaltung.py):\nVorgabe belassen.""")
      self.eingabe.feldSetzen("Eingabefeld",self.server_cgi)
      self.untenframeWarten(self.ok_button)
      self.server_cgi = self.eingabe.feldHolen("Eingabefeld")
      self.eingabe.feldSetzen("Eingabefeld","")

   

   def mysqlPasswortGui(self):
      print "hier mysqlPasswortGui"
      self.hauptlabelAusgabe("""Bitte geben Sie im Eingabefeld das "root"-Pawort \nfr ihre Mysql-Datenbank ein \n(wenn Sie keins vergeben haben, lassen Sie es weg \nund leben Sie mit weiter einer gravierenden Sicherheitslcke...). \nAchtung: Verwechseln Sie es nicht mit \n dem "Root"-Pawort fr die Linux-Systemadministration! \nMit dem Pawort wird ein neuer Mysql-User "einzelplatz" eingerichtet, \nder auf die Bezirksreiter-Datenbanken zugreifen darf. \nDer Zugriff ist auf den gleichen Rechner (localhost) beschrnkt.""")
      self.untenframeWarten(self.ok_button)
      self.mysql_root_passwort = self.eingabe.feldHolen("Eingabefeld")
      self.eingabe.feldSetzen("Eingabefeld","")
      
   def mysqlNeueDatenbankenGui(self):
      print "hier mysqlNeueDatenbankenGui"
      self.hauptlabelAusgabe("""Bitte geben Sie im Eingabefeld (mindestens!) einen \noder mehrere Namen zustzlich zur "musterkartei"\nfr neue Bezirksreiter-Datenbanken ein. \nDies ist besonders wichtig, wenn Sie bereits installierte\nBezirksreiter-Datenbanken nach einer Neuinstallation\nweiterverwenden wollen. Verwenden Sie keine Umlaute oder Sonderzeichen. \nTrennen Sie die einzelnen Namen durch einzelne Leerzeichen. \nSpter erzeugte Datenbanken (mit der Funktion Datenbank neu/leer\n werden dagegen automatisch aktiviert.""")
      self.untenframeWarten(self.ok_button)
      self.mysql_neue_datenbanken += self.eingabe.feldHolen("Eingabefeld").split(" ")
      self.eingabe.feldSetzen("Eingabefeld","")

   def mysqlRootVerbindungHerstellen(self):
      try:
         self.mysql_root_verbindung = MySQLdb.connect(db="test", host="localhost", user="root", passwd=self.mysql_root_passwort)
         self.mysql_root_cursor = self.mysql_root_verbindung.cursor()
      except:
         if not GUI:
            print "Kann keine Verbindung zum Mysql-Datenbankserver herstellen. \nServer laeuft nicht? Falsches Mysql-Pawort?"
         else:
            self.popupFehler("Kann keine Verbindung zum Mysql-Datenbankserver herstellen. \nServer luft nicht? Falsches Mysql-Pawort?")

   def datenbankenEinrichten(self,datenbanken):
      self.mysqlRootVerbindungHerstellen()
      try:
         for datenbank in datenbanken:
            self.mysql_root_cursor.execute("""grant all on %s.* to %s@localhost identified by "%s" """ % (datenbank,DATENBANK_USER,self.master_passwort))
            # hier vergeben wir Rechte fr nicht-existente Datenbanken. Geht das in jeder Mysql-Version?
         self.mysql_root_cursor.execute("""flush privileges""")
         return 1
      except:
         if not GUI:
            print "Beim Neuanlegen der Benutzerrechte ist ein Fehler aufgetreten!"
         else:
            self.popupFehler("Beim Neuanlegen der Benutzerrechte ist ein Fehler aufgetreten! \nKeine zustzlichen Datenbanknamen angegeben? \nFalsches Mysql-Pawort? Mysql-Datenbankserver luft nicht?")
         return 0
      



   def musterkarteiEinlesen(self):
      # wird nur in den Subklassen implementiert
      pass  
  
   def verzeichnisLoeschen(self,verzeichnis):
      """Eine sichere Methode, Verzeichnisse zu lschen,
      bercksichtigt ein spez. Windows-Problem."""
      verzeichnis = os.path.normpath(verzeichnis)
      os.chmod(verzeichnis,0777)      
      # wichtig fr WinNT
      time.sleep(1)
      # verzgertes Setzen der Rechte bei Windows einkalkuliert.
      if os.path.exists(verzeichnis):
         for i in os.listdir(verzeichnis):
            datei = os.path.normpath(os.path.join(verzeichnis,i))
            os.chmod(datei,0777)
            # wichtig fr Windows
         shutil.rmtree(verzeichnis)

   def protokollDictHolen(self):
      try:
         datei = open("%s" % self.installProtokoll, "rb")
         temp = cPickle.load(datei)
         datei.close()
         return temp
      except:
         if DEBUG:
            print "Installationsprotokoll lesen:\n(Noch) kein Installationsprotokoll gespeichert."
         return {}

   def protokollDictSchreiben(self,dict):
      datei = open("%s" % self.installProtokoll, "wb")
      cPickle.dump(dict,datei)
      datei.close()

   def protokollwertHolen(self,variable):
      dict = self.protokollDictHolen()
      return dict.get(variable,0)

   def protokollwertSetzen(self,variable,wert):
      dict = self.protokollDictHolen()
      dict[variable] = wert
      self.protokollDictSchreiben(dict)
      return 1

   def verzeichnisStrukturEntfernen(self):
      if not os.path.exists(self.hauptverzeichnis):
         if DEBUG:
            print "Es existiert keine alte Bezirksreiter-Installation..."
         return 1 # Abbruch
      # Achtung, Test:
      try:
         self.verzeichnisLoeschen(self.hauptverzeichnis)
         return 1
      except:
         if DEBUG:
            print "Konnte die alte Verzeichnisstruktur nicht entfernen"
         return 0

   def verzeichnisStrukturErstellen(self):
      # Achtung, Test:
      print "hier verzeichnisStrukturErstellen"
      if self.protokollwertHolen("verzeichnisstruktur"):
         # Falscher Aufruf? =>
         return 0 # Abbruch: Der Installationsvorgang Phase 1 ist bereits abgeschlossen. Sonst ===>
      if not self.verzeichnisStrukturEntfernen():
         return 0
      try:
         for verzeichnis in [self.hauptverzeichnis,self.bezirksreiter,self.recovery,self.sicherungsverzeichnis,self.vorlagenverzeichnis,self.tempinstall]:
            os.mkdir(verzeichnis)
            os.chmod(verzeichnis,0777)
         return self.protokollwertSetzen("verzeichnisstruktur",1)
      except:
         if DEBUG:
            print "Konnte keine neue Verzeichnisstruktur erstellen"
         return 0

   def verzeichnisStrukturErstellenKonsole(self):
      if self.protokollwertHolen("verzeichnisstruktur"):
         if DEBUG:
            print "Die Verzeichnisstruktur wurde bereits erstellt"
         return 0
      tempinput = raw_input("Achtung: Bei der Installation wird - wenn schon vorhanden - das gesamte Bezirksreiter-Verzeichnis mit allen Unterverzeichnissen geloescht. \nWeiter (j/n)? Buchstabe und Eingabetaste: ")
      if tempinput not in "Jj":
         return 0 # Abbruch      
      return self.verzeichnisStrukturErstellen()

   def hauptlabelAusgabe(self,text):
      self.hauptlabel.config(text=text)
      self.hauptlabel.update()

   def verzeichnisStrukturErstellenGui(self):
      if self.protokollwertHolen("verzeichnisstruktur"):
         if DEBUG:
            self.hauptlabelAusgabe("Die Verzeichnisstruktur wurde bereits erstellt")
            self.untenframeWarten(self.ok_button)
         return 0
      self.hauptlabelAusgabe("Achtung: Bei der Installation wird - wenn schon vorhanden - \ndas gesamte Bezirksreiter-Verzeichnis mit allen Unterverzeichnissen gelscht. Weiter?")
      self.untenframeWarten(self.ok_button)
      self.verzeichnisStrukturErstellen()
     ## if tempinput not in "Jj":
##         return 0 # Abbruch      
##      return self.verzeichnisStrukturErstellen()

   def verzeichnisErzeugen(self,datei_pfad):
       """Erzeugt zu einem Datei-Pfad - wenn ntig - die
       zugehrige Verzeichnishierarchie."""
       verzeichnisliste = []
       kopf = ""
       kopf = os.path.normpath(os.path.split(datei_pfad)[0])
       print kopf
       while kopf and kopf != "/" and kopf != "c:\\":
           verzeichnisliste.append(kopf)
           kopf = os.path.normpath((os.path.split(kopf))[0])
       verzeichnisliste.reverse() # zuerst das oberste Verzeichnis
       for verzeichnis in verzeichnisliste:
           try:
               if not os.path.exists(verzeichnis):
                   os.mkdir(verzeichnis)
                   os.chmod(verzeichnis,0777)
           except:
               pass

   def zipfileAuspacken(self,zipdatei,zielverzeichnis):
      try:
         z = zipfile.ZipFile(zipdatei,"r")
      except:
         print "Kann Datei %s nicht lesen! Korruptes Zip-File? " % zipdatei
         return 0 # Abbruch der Funktion
      alle = z.namelist()
      for i in alle:
         # Auspacken ...
         try:
            dname = os.path.join(zielverzeichnis,i)
            self.verzeichnisErzeugen(dname)
            if not os.path.isdir(dname):
               datei = open (dname,"wb")
               # Achtung, Binrdatei, z.B. circut5.jpg. Fr Windows deshalb ffnen im Binrmodus!
               datei.write(z.read(i))
               datei.close()
         except:
            print "Fehler beim Auspacken der Datei %s! " % zipdatei
            return 0 # Abbruch der Funktion 
      z.close()
      # Achtung, zipfile-Objekt schlieen - fr Windows, damit nichts schiefgeht.
      # Unter Unix lassen sich spter auch offene Dateien lschen.
      return 1

   def dateienInstallieren(self):
      """Installiert die Dateien aus der Bezirksreiter-Zip-Datei."""
      try:
         alle = glob.glob(os.path.join(self.hier,"Bezirksreiter*.zip"))
         neueversion = os.path.join(self.hier,os.path.basename(max(alle)))
         # Sicherheitshalber: der komplette Pfad der Bezirksreiter-Datei mit der hchsten Versionsnummer.
      except:
         print "\nKeine Installationsdatei Bezirksreiterxxxx.zip vorhanden!"
         return 0 # Abbruch der Funktion
      return self.zipfileAuspacken(neueversion,self.bezirksreiter)

   def vorlagenInstallieren(self):
      alle = glob.glob(os.path.normpath(os.path.join(self.bezirksreiter,"*.rtf")))
      sxw = glob.glob(os.path.normpath(os.path.join(self.bezirksreiter,"*.sxw")))
      alle = alle + sxw
      # RTF- und OpenOffice-Writer-Vorlagen.
      #print alle
      try:
         for vorlage in alle:
            print "Vorlage %s" % vorlage
            ziel = os.path.normpath(os.path.join(self.vorlagenverzeichnis,os.path.basename(vorlage)))
            shutil.copyfile(vorlage,ziel)
         for vorlage in alle:
            os.chmod(vorlage,0777)
            # hier noch time.sleep()?
            os.remove(vorlage)
         return 1
      except:
         print "Vorlagen konnten nicht installiert werden."
         return 0
         

   def stringErsetzenDatei(self,datei,stringalt,stringneu):
      try:
         os.chmod(datei,0777)
         f = open(datei,"rb")   
         inhalt = f.read()
         f.close()
         inhalt = string.replace(inhalt,stringalt,stringneu)
         os.chmod(datei,0777)
         time.sleep(0.5)
         # Verzgerung fr Windows - verzgerte Schreiberechtigung
         f = open(datei,"wb")
         f.write(inhalt)
         f.close()
         return 1
      except:
         return 0

   def installBeginnKonsole(self):
      """Mu plattformspezifisch sein."""
      pass

   def browserSuchen(self):
      """Mu plattformspezifisch sein. Hier nur das Protokoll:"""
      self.protokollwertSetzen("browser_gesucht",1)

   def browserSuchenKonsole(self):
      """Mu plattformspezifisch sein."""
      pass

   def startskriptErstellen(self):
      """Mu plattformspezifisch sein: hier wird nur protokolliert"""
      self.protokollwertSetzen("startskript_erstellt",1)

   def endeKonsole(self):
      """Mu plattformspezifisch sein."""
      pass

   def endeGui(self):
      """Mu plattformspezifisch sein."""
      pass

   
   def untenframeWarten(self,button):
      """Ein verschachteltes Event-Loop fr die Knpfe und das Eingabefeld unten.
      Wirkt auf das umgebende Frame."""
      button.config(command=self.untenframe.quit)
      button.config(command=self.untenframe.quit)
      self.untenframe.focus_set()
      self.untenframe.grab_set()
      self.untenframe.mainloop()
      #print "untenframeWarten beendet"

   def installKonsole(self):
      """Das ist die eigentliche Installationsprozedur:"""
      self.verzeichnisStrukturErstellenKonsole()
      if not self.installBeginnKonsole():
         # Dort wurden alle plattformspezifischen Dinge behandelt.
         # Bei Windows kommen hier z.B. 2 Neustarts "dazwischen", deshalb:
         return 1
      self.dateienInstallieren()
      self.vorlagenInstallieren()
      self.musterkarteiEinlesen()
      self.browserSuchenKonsole()
      self.startskriptErstellen()
      if self.protokollwertHolen("startskript_erstellt"):
         # ganz am Schlu wird aufgerumt...
         self.verzeichnisLoeschen(self.tempinstall)
         self.endeKonsole()

   def installGui(self):
      """Das ist die eigentliche Installationsprozedur:"""
      print "Hier ist installGui"
      self.hauptlabelAusgabe(self.systemmeldung+"""\n\nBitte bettigen Sie zum Fortfahren jeweils \nden "Weiter"-Knopf. Geben Sie auf Anforderung \nWerte in das Eingabefeld ein.""")
      self.untenframeWarten(self.ok_button)
      self.mxDateTimePruefen()
      # Debian-Package-Maintainer-Kommentar ("DPMK"): Es wird geprft, ob das egenix-date-time-Modul fr Python
      # installiert ist und eine Empfehlung zur Deinstallation ausgegeben (diese ist nicht zwingend, sorgt aber
      # fr wesentlich bessere Performance des Bezirksreiters.)
      self.verzeichnisStrukturErstellenGui()
      # DPMK: Die Verzeichnisstruktur fr den Bezirksreiter wird erstellt. Ist sie schon vorhanden, werden die Verzeichnisse
      # und Dateien gelscht und neu erstellt.
      if not self.installBeginnGui():
         # Dort wurden alle plattformspezifischen Dinge behandelt.
         # Bei Windows kommen hier z.B. 2 Neustarts "dazwischen", deshalb:
         self.neustartVorbereiten() # gibt es nur bei Windows-Systemen!
         self.hauptfenster.destroy()
      # DPMK: Das Mysql-Root-Pawort wird abgefragt. Die Namen zustzlich gewnschter Datenbanken (zustzlich zu "musterkartei" und
      # "musterevang") werden abgefragt und die ntigen Rechte eingerichtet fr den User "einzelplatz" und das Pawort "hallo".
      # Benutzername und Pawort mssen bei der jetzigen Einzelplatz-Version so lauten.
      # Achtung, Test:
      self.installModusGui()
      if self.vereinfachteInstallation != "ja":
         self.masterPasswortGui() #
      self.adminNameGui()
      self.emailEingabeGui()
      self.adminPasswortGui()
      if self.vereinfachteInstallation != "ja":
         self.schaltzentraleGui() #
         self.serverCgiGui() #
         self.mysqlNeueDatenbankenGui() #
      test = self.datenbankenEinrichten(self.mysql_neue_datenbanken)
      self.passwortDateiErzeugen()
      self.adminCheckinErzeugen()
      if not self.dateienInstallieren():
         # DPMK: Die Programmdateien, statische HTML-Seiten etc. werden in das Bezirksreiter-Verzeichnis kopiert.
         print "fehler: dateien installieren"
         self.popupFehler()
      self.linksUmwandeln() # falls nicht localhost:8000 fr die Einzelplatz-Installation.
      self.adminConfigErzeugen() # Modifikation von config.py nach oben erfolgtem Auspacken.
      if not self.vorlagenInstallieren():
         # DPMK: Die Vorlagen-Dateien werden in das Vorlagenverzeichnis kopiert.
         print "fehler: vorlagen installieren"
         self.popupFehler()
      print "vorlagen installiert"   
      if not self.musterkarteiEinlesen():
         # DPMK: in den Musterkarteien "musterlin.sql" und "musterlin_evang.sql" wird der String "heimatverzeichnis" durch
         # den absoluten Pfad zum Heimatverzeichnis ersetzt (wre bei Debian dann "/var/www"?).
         # Dann werden die vernderten SQL-Dateien in die Datenbank eingelesen.
         print "fehler: musterkartei einlesen"
         self.popupFehler()
      self.browserSuchenGui()
      # DPMK: Der Kommandozeilenbefehl fr den bzw. gesamte Pfad zu dem Lieblingsbrowser wird abgefragt.
      self.startskriptErstellen()
      # DPMK: In der Startskriptvorlage werden die Werte fr das Bezirksreiter-Wurzelverzeichnis und den Pfad
      # fr den Lieblingsbrowser eingesetzt. Das erstellte Startskript wird in das Bezirksreiter-Programmverzeichnis
      # zu den anderen Python-Dateien kopiert und mit "chmod a+x" ausfhrbar gemacht.
      if self.protokollwertHolen("startskript_erstellt"):
         # ganz am Schlu wird aufgerumt... DPMK: das Folgende wre fr Debian nicht ntig.
         self.verzeichnisLoeschen(self.tempinstall)
         self.endeGui()
         self.hauptfenster.destroy()

   
      

class LinuxInstall(Install):
   """Plattformspezifische Implementierung der Klasse Install."""
   def __init__(self,systemmeldung):
      self.hauptverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter")
      self.bezirksreiter = os.path.join(os.environ["HOME"],"Bezirksreiter/Bezirksreiter")
      self.recovery = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterAlt")
      self.tempinstall = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterInstall")
      self.updateverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterUpdate")
      self.startmethode = "von einer Konsole mit dem Befehl \"python ./update.py\" "
      self.sicherungsverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterSicherung")
      self.vorlagenverzeichnis = os.path.join(os.environ["HOME"],"Bezirksreiter/BezirksreiterVorlagen")
      self.musterkartei_sql = ("musterlin.sql","musterlin_evang.sql","musterlin_emkadressen.sql")
      self.hier = os.curdir # erspart den Aufruf aus dem aktuellen Verzeichnis heraus?
      Install.__init__(self,systemmeldung)

   def hauptfensterErzeugen(self):      
      self.systemmeldung += "\nBitte vergewissern Sie sich, da Sie \ndas Programm von einer Konsole aus \naufgerufen haben."
      # Bei Linux darf nicht etwa mit dem KDE-"Run"-Fenster (ALT-F2) aufgerufen werden, sonst gibt es Probleme
      # mit den Umgebungsvariablen.
      Install.hauptfensterErzeugen(self)

   def installBeginnKonsole(self):
      return 1 # weil noch nicht weiter implementiert

   def installBeginnGui(self):
      test = 0
      self.mysqlPasswortGui()
      #self.mysqlNeueDatenbankenGui()
      #test = self.datenbankenEinrichten(self.mysql_neue_datenbanken)
      return 1
      

   def musterkarteiEinlesen(self):
      for musterdatei in self.musterkartei_sql:
         returnflag = 1
         if DEBUG:
            print "Einlesen:",musterdatei,self.musterkartei_sql
         musterkarteipfad = os.path.normpath(os.path.join(self.bezirksreiter,musterdatei))
         if not self.stringErsetzenDatei(musterkarteipfad,"heimatverzeichnis",os.environ["HOME"]):
            # fr Linux mu unter "Optionen" das Heimatverzeichnis explizit angegeben werden,
            # nur ~/BezirksreiterSicherung usw. funktioniert nicht.
            print "%s konnte nicht korrekt verarbeitet werden. Abbruch!" % musterdatei
            returnflag=0
         try:
            temp = os.system("""mysql -u root --password=%s < %s """ % (self.mysql_root_passwort,musterkarteipfad))
            if not temp:
               returnflag=1
            else:
               print """\nKonnte die Musterkartei nicht einlesen. \nKeine Berechtigung? Falsches Mysql-Root-Passwort?"""
               returnflag=0
         except:
            print """\nKonnte den Mysql-Server nicht erreichen! "mysld" aufrufen (ggf. als "root") !"""
            returnflag=0
      return returnflag

   def browserSuchenKonsole(self):
      eingabe = raw_input("Bitte geben Sie ein, wie Ihr Lieblingsbrowser \nvon der Kommandozeile gestartet wird (konqueror,mozilla...).\nVergessen Sie nicht, ggf. den Pfad \nhinzuzufuegen (wenn der Befehl nicht systemweit aufrufbar ist): ")
      # TODO: einen Pfad-Test einbauen
      self.lieblingsbrowser = eingabe
      self.browserSuchen()

   def browserSuchenGui(self):
      print "hier browsersuchenGui"
      self.hauptlabelAusgabe("Bitte geben Sie im Eingabefeld ein, wie Ihr Lieblingsbrowser \nvon der Kommandozeile gestartet wird (konqueror,mozilla...).\nVergessen Sie nicht, ggf. den Pfad \nhinzuzufgen (wenn der Befehl nicht systemweit aufrufbar ist): ")
      #self.ok_button.config(command=self.browserEintragenGui)
      self.untenframeWarten(self.ok_button)
      self.lieblingsbrowser = self.eingabe.feldHolen("Eingabefeld")
      #self.eingabe_warten.set()
      self.browserSuchen()


   def browserSuchen(self):
      Install.browserSuchen(self)

   def endeKonsole(self):
      print "Installation fertig!\nLoggen Sie sich zunaechst in der Datenbank %s, Buchungsjahr 2004 ein. " % self.musterkartei

   def endeGui(self):
      self.hauptlabelAusgabe("""Installation fertig!\nStarten Sie den Bezirksreiter durch \n"python %s/BezirksreiterStart" \nvon der Konsole. \nLoggen Sie sich zunchst in der Datenbank %s, Buchungsjahr 2004 ein.""" % (self.bezirksreiter,self.musterkartei[0]))
      self.ok_button.config(text="Beenden")
      self.untenframeWarten(self.ok_button)

   def startskriptErstellen(self):
      startdateipfad = os.path.join(self.bezirksreiter,"BezirksreiterStart")
      startdatei = open(startdateipfad,"wb")
      startskript = """#!/bin/sh
cd %s
python cgiserver_verwaltung.py > /dev/null&
%s %s&
# Es wird davon ausgegangen, da bei einer
# Linux-Standardinstallation von Mysql
# der Server (mysqld, luft mit root-Rechten)
# beim Hochfahren automatisch gestartet wird
# - hier also nicht mehr.
# Ansonsten ist das in den init-Leveln zu ndern,
# z.B. mit ksysv.
# Im Zweifelsfall E-Mail an me.simon@t-online.de ...
      """ % (self.bezirksreiter,self.lieblingsbrowser,urlparse.urljoin(self.url,self.frame_datei))
      startdatei.write(startskript)
      startdatei.close()
      os.system("""chmod a+x %s""" % startdateipfad)
      # Startskript ausfhrbar machen
      Install.startskriptErstellen(self)

class WindowsInstall(Install):
   """Plattformspezifische Implementierung der Klasse Install."""
   def __init__(self,systemmeldung):
      self.hauptverzeichnis = """c:/Bezirksreiter"""
      self.bezirksreiter = """c:/Bezirksreiter/Bezirksreiter"""
      self.recovery = """c:/Bezirksreiter/BezirksreiterAlt"""
      self.tempinstall = """c:/Bezirksreiter/BezirksreiterInstall"""
      self.updateverzeichnis = """c:/Bezirksreiter/BezirksreiterUpdate"""
      self.startmethode = "durch Doppelklicken im Explorer. Achtung: Bei manchen Explorer-Einstellungen fehlt die Endung \".py\"!"
      self.sicherungsverzeichnis = """c:/Bezirksreiter/BezirksreiterSicherung"""
      self.vorlagenverzeichnis = """c:/Bezirksreiter/BezirksreiterVorlagen"""
      self.musterkartei_sql = ("musterwin.sql","musterwin_evang.sql","musterwin_emkadressen.sql")
      self.mysql_pfad = "c:/mysql/bin"
      self.mysqld_datei = os.path.normpath(os.path.join(self.mysql_pfad,"mysqld.exe"))
      self.startskript_dateiname = "BezirksreiterStart.py"
      self.startskript = os.path.normpath(os.path.join(self.bezirksreiter,self.startskript_dateiname))
      self.createLink = os.path.normpath(os.path.join(self.bezirksreiter,"createLnk.exe"))
      self.iconpath = os.path.normpath(os.path.join(self.bezirksreiter,"Bezirksreiter.ico"))     
      # self.startskript = os.path.normpath(os.path.join(self.bezirksreiter,"BezirksreiterStart.py"))
      # Achtung, dieser Pfad ist ggf. anzupassen -
      # vgl. dazu auch den Eintrag "Datenbankverzeichnis" in der Tabelle optionenxxxx.
      self.neustart_flag = 0
      self.lieblingsbrowser = ""
      self.hier = os.getcwd()
      Install.__init__(self,systemmeldung)

   def installBeginnKonsole(self):
      # Veraltet und nicht berarbeitet:
      self.mysqlInstallierenKonsole()
      self.mysqlPfadAutoexecBat()
      if self.neustart_flag:
         return 0
      self.mysqldbInstallierenKonsole()
      self.mysqlAlsDienst()
      if self.neustart_flag:
         return 0
      return 1

   def installBeginnGui(self):
      self.mysqlInstallierenGui()
      self.mysqlPfadAutoexecBat()
      if self.neustart_flag:
         return 0
      self.mysqldbInstallierenGui()
      self.mysqlAlsDienst()
      if self.neustart_flag:
         return 0
      self.reportlabInstallieren()
      self.pilInstallierenGui()
      if self.neustart_flag:
         return 0
      #self.mysqlNeueDatenbankenGui()
      #test = self.datenbankenEinrichten(self.mysql_neue_datenbanken)
      return 1

   def endeKonsole(self):
      print "\n********************"
      print "!!!!Geschafft!!!!!!!"
      print "Starten Sie zum vierten (und letzten) \n Mal das System neu."
      print "\nStarten Sie dann den \nBezirksreiter aus dem Explorer durch Doppelklick \nauf c:/Bezirksreiter/BezirksreiterStart.py!"
      print "Steigern Sie den Komfort, indem Sie \nmit dem Explorer eine Verknuepfung auf den Desktop"
      print "erstellen: Ziehen BezirksreiterStart.py \nmit der rechten Maustaste auf den Desktop (Windows 95)!"
      print "Bestaetigen sie mit \"Hier Verknuepfung erstellen\"!"
      print "**********************"
      eingabe = raw_input("Zum Weiterlesen bitte Eingabetaste druecken!")
      print "\nAchtung: Nach der Neuinstallation \ndes Bezirksreiters ist (manchmal) \n im Browser die \"Neu laden\" bzw. \"Aktualisieren\"-Taste zu\n betaetigen, erst dann erscheint der Startbildschirm!\n\n"  
      print "\nLoggen Sie sich nach dem Start des \nBezirksreiters zunaechst in der \nDatenbank %s, Buchungsjahr 2004 ein. " % self.musterkartei

   def endeGui(self):
      self.hauptlabelAusgabe("""!!!!Geschafft!!!!!!! Starten Sie zum \nvierten (und letzten) Mal das System neu. \nStarten Sie dann den \nBezirksreiter aus dem Explorer durch Doppelklick \nauf c:/Bezirksreiter/BezirksreiterStart.py, \noder Doppelklick auf das neue \nBezirksreiter-Symbol auf dem Desktop! """)
      self.untenframeWarten(self.ok_button) 
      self.hauptlabelAusgabe("""Achtung: Nach der Neuinstallation \ndes Bezirksreiters ist (manchmal) \n im Browser die \"Neu laden\" bzw. \"Aktualisieren\"-Taste zu\n betaetigen, erst dann erscheint der Startbildschirm!\n\nLoggen Sie sich nach dem Start des \nBezirksreiters zunaechst in der \nDatenbank %s, Buchungsjahr 2004 ein. """ % self.musterkartei[0])
      self.untenframeWarten(self.ok_button)

   def browserSuchenGui(self):
      print "hier browsersuchenGui"
      #self.hauptlabelAusgabe("Bitte geben Sie im Eingabefeld ein, wie Ihr Lieblingsbrowser \nvon der Kommandozeile gestartet wird (Internet-Explorer, Netscape...).\nVergessen Sie nicht, ggf. den Pfad \nhinzuzufgen (wenn der Befehl nicht systemweit aufrufbar ist). \nSie knnen das Eingabefeld auch leer lassen. \nWir nehmen dann den von Windows registrierten Standardbrowser.  ")
      #self.ok_button.config(command=self.browserEintragenGui)
      #self.untenframeWarten(self.ok_button)
      #self.lieblingsbrowser = self.eingabe.feldHolen("Eingabefeld")
      #self.eingabe_warten.set()
      self.browserSuchen()


   def browserSuchen(self):
      Install.browserSuchen(self)



##   def browserSuchen(self,dir,browsername,ausdruck):
##      dir = os.path.normpath(dir)
##      alle = os.listdir(dir)
##      temp = glob.glob(os.path.join(dir,ausdruck))
##      if temp != []:
##         neudir = dir
##         mobj = self.spacetest.search(dir)
##         if mobj:
##            temp1 = mobj.group(1)
##            neudir = dir.replace(temp1,"%s~1" % temp1[:6])
##            print neudir
##         print temp[0]
##         self.browser[browsername] = os.path.join(neudir,os.path.basename(temp[0]))
##      for i in alle:
##         if os.path.isdir(os.path.join(dir,i)):
##            # Achtung, Test:
##            try:
##               self.browserSuchen(os.path.join(dir,i),browsername,ausdruck)
##            except:
##               pass
##      Install.browserSuchen(self)

##   def browserSuchenKonsole(self):
##      print "Es koennen nun die Browser gesucht werden,\n die auf ihrer ersten Festplatte installiert sind.\n(Netscape, InternetExplorer, Mozilla)\nDies kann einige Zeit dauern."
##      temp = raw_input("Moechten Sie statt dessen \nden registrierten Standardbrowser\n ihres Systems verwenden (empfohlen) ?\nEingabe j/n: ")
##      if temp in "Jj":
##         self.lieblingsbrowser = ""
##         print "Keine Suche! Wir nehmen den registrierten Standardbrowser."
##         return 1 # Abbruch hier...         
##      print "\nBrowser werden gesucht, bitte warten...\n"
##      self.browserSuchen("c:/","Netscape","netscape*.exe")
##      print "Bitte warten..."
##      self.browserSuchen("c:/","InternetExplorer","iexplore*.exe")
##      print "Bitte warten..."
##      self.browserSuchen("c:/","Mozilla","mozilla.exe")
##      if self.browser == {}:
##         eingabe = raw_input("""\nPfade zu Netscape, InternetExplorer\n und Mozilla nicht gefunden! \nWir versuchen den registrierten Standardbrowser.\nEingabetaste fuer weiter: """)
##            # In das Start-Skript wird "" eingesetzt beim Browser, also die Anwendung gestartet, die
##            # in Windows fr .htm-Dateien registriert ist.
##         self.lieblingsbrowser = ""
##      else:
##         for i in self.browser.keys():
##            print "\n%s gefunden!" % i
##         browserflag = 0
##         for i in self.browser.keys():
##            eingabe = raw_input("\n%s verwenden (j/n)? " % i)
##            if eingabe == "j":
##               self.lieblingsbrowser = self.browser[i]
##               browserflag = 1
##               break
##         if not browserflag:
##            self.lieblingsbrowser = ""
##            print "Keine Wahl getroffen! Wir nehmen den registrierten Standardbrowser."

   def mysqlPfadAutoexecBat(self):
      if not self.protokollwertHolen("mysqlpfad_in_autoexec_bat"):
         try:
            f = open("c:/autoexec.bat","a")
            f.write("\n\n")
            f.write("""PATH=C:\\mysql\\bin;C:\\Python2%s;""" % sys.version_info[1] + """%PATH%""")
            # Die Pfade fr Python 2.1, 2.2 und 2.3 sind unterschiedlich.
            f.write("\nrem Die Pfade fuer Mysql und Python werden hinzugefuegt.")
            f.close()
            self.protokollwertSetzen("mysqlpfad_in_autoexec_bat",1)
            return 1
         except:
            if DEBUG:
               print "Konnte die Pfade fuer Mysql und Python nicht zur \nautoexec.bat hinzufuegen. Mache weiter..."
            return 0

   def neustartVorbereiten(self):
      self.hauptlabelAusgabe("""Klicken Sie auf "Beenden" und \nstarten Sie dann das System neu!""")
      self.ok_button.config(text="Beenden")
      self.untenframeWarten(self.ok_button)

   def mysqlTesten(self):
      if os.path.exists(self.mysqld_datei):
         if DEBUG:
            print "Mysql-Datenbank gefunden!"
         return 1
      else:
         return 0

   def mysqlRootVerbindungHerstellen(self):
      # Wir gehen davon aus, dass unter Windows der immer vorhandene
      # Default-User "ODBC" (nach der Schnittstelle") heit.
      try:
         if not win_nt:
            # ein scheulicher Patch
            os.system("""%s""" % self.mysqld)
      except:
         # wenn der Server schon luft oder bei NT, weil es hier kein self.mysqld gibt usw.
         pass
      try:
         self.mysql_root_verbindung = MySQLdb.connect(db="test", host="localhost", user="ODBC")
         self.mysql_root_cursor = self.mysql_root_verbindung.cursor()
      except:
         if not GUI:
            print "Kann keine Verbindung zum Mysql-Datenbankserver herstellen. \nServer laeuft nicht?"
         else:
            self.popupFehler("Kann keine Verbindung zum Mysql-Datenbankserver herstellen. \nServer luft nicht?")

   def mysqlInstallieren(self):
      if self.mysqlTesten():
         return 1
      try:
         alle = glob.glob(os.path.join(self.hier,"mysql-3.*zip"))
         neueversion = os.path.join(self.hier,os.path.basename(max(alle)))
         # Sicherheitshalber: der komplette Pfad mit der hchsten Versionsnummer.
      except:
         if DEBUG:
            print "\nKeine Installationsdatei mysqlxxxx.zip vorhanden!"
         return 0 # Abbruch der Funktion
      if not self.zipfileAuspacken(neueversion,self.tempinstall):
         if DEBUG:
            print "Mysql konnte nicht in das Installationsverzeichnis entpackt werden!"
            return 0
      os.system(r"start %s" % os.path.normpath(os.path.join(self.tempinstall,"setup.exe")))
      self.protokollwertSetzen("mysql_installiert",1)
      self.neustart_flag = 1                
      return 1

   def reportlabInstallieren(self):
      # Achtung, setzt angepasstes Reportlab-Archiv voraus!
      # vernderte Archiv-Pfade gegenber der Hersteller-Version.
      if self.reportlabTesten():
         return 1
      try:
         alle = glob.glob(os.path.join(self.hier,"ReportlabBezirksreiter*.zip"))
         neueversion = os.path.join(self.hier,os.path.basename(max(alle)))
         # Sicherheitshalber: der komplette Pfad mit der hchsten Versionsnummer.
      except:
         if DEBUG:
            print "\nKeine Installationsdatei ReportlabBezirksreiterxxxx.zip vorhanden!"
         return 0 # Abbruch der Funktion
      pythonpfad = os.path.normpath("c:/Python2%s/Lib/site-packages" % sys.version_info[1])
      if not self.zipfileAuspacken(neueversion,pythonpfad):
         if DEBUG:
            print "ReportLab konnte nicht korrekt in die Python-Installation entpackt werden!"
            return 0
      self.protokollwertSetzen("reportlab_installiert",1)
      return 1

   def mysqlInstallierenKonsole(self):
      print "hier mysql-installieren-konsole"
      if self.mysqlTesten():
         return 1
      t = raw_input("\n\nDie Mysql-Datenbank wird nun installiert.\nBitte alle Voreinstellungen uebernehmen: \nKlicken Sie dazu jeweils auf \"Next\", zum Schluss auf \"Finish\".\nNach der Installation System neu starten. \nNach dem Neustart bitte auf install(.py) doppelklicken.\nEingabetaste zum Start der Installation")
      return self.mysqlInstallieren()

   def mysqlInstallierenGui(self):
      print "hier mysql-installieren-gui"
      if self.mysqlTesten():
         return 1
      self.hauptlabelAusgabe("""\n\nDie Mysql-Datenbank wird nun installiert. \nBitte alle Voreinstellungen uebernehmen: \nKlicken Sie dazu jeweils auf \"Next\", zum Schlu auf \"Finish\".\nNach der Installation System neu starten. \nNach dem Neustart bitte auf install(.py) doppelklicken.\n"Weiter" zum Start der Installation bettigen. """)
      self.untenframeWarten(self.ok_button)
      temp = self.mysqlInstallieren()
      if not temp:
         self.popupFehler()
      return temp

   def mysqlAlsDienst(self):
      """Gibt es nur fr NT, deshalb hier nur das Protokoll:"""
      self.protokollwertSetzen("mysql_als_dienst",1)

   def reportlabTesten(self):
      try:
         import reportlab
         if DEBUG:
            print "Python-Reportlab gefunden!"
         return 1
      except:
         return 0

   def pilTesten(self):
      try:
         import PIL
         if DEBUG:
            print "Python-Imaging-Library(PIL) gefunden!"
         return 1
      except:
         return 0    

   def mysqldbTesten(self):
      try:
         import MySQLdb
         if DEBUG:
            print "Mysql-Python-Modul gefunden!"
         return 1
      except:
         return 0

   def pilInstallieren(self):
      if self.pilTesten():
         return 1
      try:
         alle = glob.glob(os.path.join(self.hier,"PIL*2.3.exe"))
         neueversion = os.path.join(self.hier,os.path.basename(max(alle)))
         # Sicherheitshalber: der komplette Pfad mit der hchsten Versionsnummer.
         os.system(r"start %s" % neueversion)
         self.protokollwertSetzen("pil_installiert",1)
         self.neustart_flag = 1
         return 1
      except:
         if DEBUG:
            print "\nKeine Installationsdatei PILxxx2.3.exe vorhanden!"
         return 0

   def mysqldbInstallieren(self):
      if self.mysqldbTesten():
         return 1
      try:
         alle = glob.glob(os.path.join(self.hier,"mysql-python*exe"))
         neueversion = os.path.join(self.hier,os.path.basename(max(alle)))
         # Sicherheitshalber: der komplette Pfad mit der hchsten Versionsnummer.
         os.system(r"start %s" % neueversion)
         self.protokollwertSetzen("mysqldb_installiert",1)
         self.neustart_flag = 1
         return 1
      except:
         if DEBUG:
            print "\nKeine Installationsdatei mysql-pythonxxx.exe vorhanden!"
         return 0

   def mysqldbInstallierenKonsole(self):
      if self.mysqldbTesten():
         return 1
      t = raw_input("\nDas Python-Datenbank-Modul MySQLdb wird nun\ninstalliert. Bitte alle Voreinstellungen uebernehmen:\nKlicken Sie dazu jeweils auf \"weiter\", zum Schluss auf \"Fertig stellen\".\nDanach das System neu starten.\nDoppelklicken Sie nach dem Neustart wieder auf install.py!\nEingabetaste betaetigen fuer den Start der Installation: ")
      return self.mysqldbInstallieren()

   def mysqldbInstallierenGui(self):
      if self.mysqldbTesten():
         return 1
      self.hauptlabelAusgabe("""\nDas Python-Datenbank-Modul MySQLdb wird nun\ninstalliert. Bitte alle Voreinstellungen uebernehmen:\nKlicken Sie dazu jeweils auf \"weiter\", zum Schluss auf \"Fertig stellen\".\nDanach das System neu starten.\nDoppelklicken Sie nach dem Neustart wieder auf install.py!\n"Weiter" fr den Start der Installation: """)
      self.untenframeWarten(self.ok_button)
      temp = self.mysqldbInstallieren()
      if not temp:
         self.popupFehler()
      return temp

   def pilInstallierenGui(self):
      if self.pilTesten():
         return 1
      if ("%s" % sys.version_info[1]) != "3":
         self.popupWarnung("""Sie haben eine andere Python-Version als 2.3\nDie Python-Imaging-Library kann deshalb\nnicht installiert werden. =>\nMglicherweise bekommen Sie Probleme mit der PDF-Ausgabe.""")
         return 1
      self.hauptlabelAusgabe("""\nDie Python-Imaging-Library wird nun\ninstalliert. Bitte alle Voreinstellungen uebernehmen:\nKlicken Sie dazu jeweils auf \"weiter\", zum Schluss auf \"Fertig stellen\".\nDanach das System neu starten.\nDoppelklicken Sie nach dem Neustart wieder auf install.py!\n"Weiter" fr den Start der Installation: """)
      self.untenframeWarten(self.ok_button)
      temp = self.pilInstallieren()
      if not temp:
         self.popupFehler()
      return temp   

   def musterkarteiEinlesen(self):
      # Achtung, Test: der Start des Mysql-Servers fr Win95 ist nach mysqlRootVerbindungHerstellen verlagert.
      returnflag = 1
      for musterdatei in self.musterkartei_sql:
         musterkarteipfad = os.path.normpath(os.path.join(self.bezirksreiter,musterdatei))      
         # if not os.path.exists(self.mysql):
         #   print """Pfad fr Mysql-Datenbank nicht gefunden unter %s !""" % self.mysql
         #   print """ggf. ist ein Patch durchzufuehren: Modul update.py, class WindowsInstall, __init__(), self.mysql_pfad = ..."""
         #   print """oder E-Mail an me.simon@t-online.de."""
         #   return 0 # Abbruch der Funktion
         # Und jetzt das Einlesen:
         befehl = """%s < %s """ % (self.mysql,musterkarteipfad)
         print "gleich: musterkartei einlesen"
         test = os.system(befehl)
         # Einlesen der Musterdatenbank bzw. Wiederherstellen:
         if test:
            print "Achtung, Musterdatenbank(en) konnte(n) nicht eingelesen werden!"
            returnflag=0 # Abbruch
         else:
            returnflag=1
      return returnflag
      
   def desktopLink(self):
      # Dank an die australische Firma, die das C-Programm createLnk geschrieben hat.
      os.system("""%s %s %s "Bezirksreiter" %s "Link zu Bezirksreiter" "" %s """ % (self.createLink,self.bezirksreiter,self.startskript_dateiname,self.bezirksreiter,self.iconpath))

      

class Windows95Install(WindowsInstall):
   """Einige Dinge sind fr 95/98/ME zu unterscheiden."""
   def __init__(self,systemmeldung):
      self.mysql_pfad = "c:/mysql/bin"
      self.mysqld = """start %s""" % os.path.normpath(os.path.join(self.mysql_pfad,"mysqld.exe"))
      self.mysql = """start %s""" % os.path.normpath(os.path.join(self.mysql_pfad,"mysql.exe"))
      self.mysqldump =  """start %s""" % os.path.normpath(os.path.join(self.mysql_pfad,"mysqldump.exe"))
      if DEBUG:
         print self.mysqld, self.mysql, self.mysqldump
      WindowsInstall.__init__(self,systemmeldung)

   def startskriptErstellen(self):
      startdatei = open(self.startskript,"wb")
      startskript = """
import os
import time
os.system(r"%s")
# Mysql-Server starten
os.system(r"start %s")
# Bezirksreiter-Server starten
# Der folgende Pfad fr den Browser ist bei Strungen zu berprfen. Achten Sie auf
# abgekrzte DOS-Pfade wie "micros~1". Sie wurden eingefgt, um einen Ersatz fr
# Pfade mit Spaces (z.B.: c:\Microsoft Internet\) zu finden.
# rufen Sie ggf. die "MS-DOS-Eingabeaufforderung" auf, berprfen Sie den
# abgekrzten DOS-Pfad.
# Sie knnen den Pfad auch ganz entfernen (wenn das noch nicht der Fall ist)
# Also: "start ..../verwaltungMain.htm" - dann wird der registrierte
# Standardbrowser verwendet.
# Ansonsten: E-Mail an me.simon@t-online.de...
time.sleep(1)
# eine Verzgerungsschleife, damit der Server hochfahren kann, bevor der Browser startet.
os.system(r"start %s %s")
      """ % (self.mysqld,os.path.normpath(os.path.join(self.bezirksreiter,"cgiserver_verwaltung.py")),self.lieblingsbrowser,urlparse.urljoin(self.url,self.frame_datei))
      startdatei.write(startskript)
      startdatei.close()
      time.sleep(1)
      self.desktopLink()
      Install.startskriptErstellen(self)
      

class WindowsNTInstall(WindowsInstall):
   """Einige Dinge sind fr NT / XP zu unterscheiden."""
   def __init__(self,systemmeldung):
      self.mysql_pfad = "c:/mysql/bin"
      self.mysql = os.path.normpath(os.path.join(self.mysql_pfad,"mysql"))
      self.mysqldump =  os.path.normpath(os.path.join(self.mysql_pfad,"mysqldump"))
      self.mysqld = os.path.normpath(os.path.join(self.mysql_pfad,"mysqld-max-nt"))
      WindowsInstall.__init__(self,systemmeldung)

   def mysqlAlsDienst(self):
      if self.protokollwertHolen("mysql_als_dienst"):
         if DEBUG:
            print "Mysql-Dienst fuer NT/XP bereits installiert!"
         return 1
      test = 0
      test = os.system(r"start %s --install" % self.mysqld)
      if test:
         if DEBUG:
            print "Konnte die Mysql-Datenbank nicht als Dienst installieren!"
         return 0
      if DEBUG:
         print "Die Mysql-Datenbank wird als Dienst installiert!"
      WindowsInstall.mysqlAlsDienst(self)
      return 1

   def startskriptErstellen(self):
      startdatei = open(self.startskript,"wb")
      startskript = """
import os
import time
os.system(r"start %s")
# Der folgende Pfad fr den Browser ist bei Strungen zu berprfen. Achten Sie auf
# abgekrzte DOS-Pfade wie "micros~1". Sie wurden eingefgt, um einen Ersatz fr
# Pfade mit Spaces (z.B.: c:\Microsoft Internet\) zu finden.
# rufen Sie ggf. die "MS-DOS-Eingabeaufforderung" auf, berprfen Sie den
# abgekrzten DOS-Pfad.
# Sie knnen den Pfad auch ganz entfernen (wenn das noch nicht der Fall ist)
# Also: "start ..../verwaltungMain.htm" - dann wird der registrierte
# Standardbrowser verwendet.
# Ansonsten: E-Mail an me.simon@t-online.de...
time.sleep(1)
# eine Verzgerungsschleife, damit der Server hochfahren kann, bevor der Browser startet.
os.system(r"start %s %s")
      """ % (os.path.normpath(os.path.join(self.bezirksreiter,"cgiserver_verwaltung.py")),self.lieblingsbrowser,urlparse.urljoin(self.url,self.frame_datei))
      startdatei.write(startskript)
      startdatei.close()
      time.sleep(1)
      self.desktopLink()
      Install.startskriptErstellen(self)


def plattformTesten():
    # vgl. das Modul verschiedeneUtilities
    win = 0
    win_nt = 0
    try:
        if sys.platform[:3] == "win":
            win = 1
            try:
                if (os.environ["OS"].lower()).find("nt") != -1 and win:
                    # os.environ["OS"] nicht unter Linux und Win95!
                    win_nt = 1
            except:
                pass
    except:
        pass
    return win, win_nt

win, win_nt = plattformTesten()
 
# Globale Modul-Funktion als "Factory":
def UniversalInstall():
   global win, win_nt
   meldung = "test"
   if not win:
      if DEBUG:
         meldung = "Linux/Unix-System erkannt!"
      return LinuxInstall(meldung)         
   else:
      if win_nt:
         if DEBUG:
            meldung = "Windows NT/2000/XP-System erkannt!"
         return WindowsNTInstall(meldung)
      else:
         if DEBUG:
            meldung = "Windows 95/98/ME-System erkannt!"
         return Windows95Install(meldung)


if __name__ == "__main__":
   # Wenn als eigener Skript, nicht als Unterprogramm:
   # Achtung, Test
   try:
      inst = UniversalInstall()
      # das o.g. mte noch in einen try-except-block fr die GUI-Ausnahmen
      if not GUI:
         print meldung
         inst.installKonsole()
      else:
         #inst.installGui() wird aus dem Hauptfenster aufgerufen.
         #print meldung
         pass
   except:
      if win: # and not win_nt:
         pass # Windows95 produziert unntige Fehlermeldungen, XP leider auch manchmal...
      else:      
         if not GUI:
            print "Bei der Installation ist ein Fehler aufgetreten.\n"
         else:
            root = Tk()
            Label(root,text="Bei der Installation des Bezirksreiters \nist ein Fehler aufgetreten").pack()
            Button(root,text="Beenden",command=root.destroy).pack()
            root.mainloop()
         
   if not GUI:
      # Damit bei Windows das Fenster nicht einfach "verschwindet".
      temp = raw_input("Eingabetaste zum Beenden: ")






